import os
from argparse import ArgumentParser


PROG_NAME = "DianaXO"
VERSION = (0, 1, 0)

cur_dir = os.path.dirname(__file__)

parser = ArgumentParser()
parser.add_argument("--encoding")
parser.add_argument("-s", "--suffix")
parser.add_argument("-r", "--recursive")
parser.add_argument("-i", "--input", nargs="+", required=True)
parser.add_argument("-o", "--output")
parser.add_argument("--format", choices={"svg", "tikz"})
parser.add_argument("-k", "--keep-broken")
parser.add_argument("--moves-p-d", type=int)
parser.add_argument("--min-p-d", type=int)
parser.add_argument("--version", action="version", version="{0} {1}.{2}.{3}".format(PROG_NAME, *VERSION))


input_files = []
encoding = "utf-8-sig"
sgf_suffix = True
recursive = False
output_dir = cur_dir
output_format = "svg"
keep_broken = False

moves_per_diagram = 100
min_moves_per_diagram = 10


def parse_args():
	global input_files, encoding, sgf_suffix, recursive, output_dir, output_format, keep_broken, moves_per_diagram
	global min_moves_per_diagram

	args = parser.parse_args()

	input_files = args.input
	if args.encoding: encoding = args.encoding
	if args.suffix: sgf_suffix = True
	if args.recursive: recursive = True
	if args.output: output_dir = args.output
	if args.format: output_format = args.format
	if args.keep_broken is not None: keep_broken = True

	if args.moves_p_d: moves_per_diagram = args.moves_p_d
	if args.min_p_d: min_moves_per_diagram = args.min_p_d
